# Quick Bite
## Projeto de HDDL, TEES 2023.1

---

## Participantes
- Caio Ivo Fortes Urnau
- Ryan Augusto Brandão Salles
- João Ismael Machado Monasterio

## Sobre
O *Quick Bite* é um domínio em HDDL que representa, de maneira simplificada, um restaurante ou lanchonete. Os dois principais
atores do domínio são o garçom, que é responsável por receber os pedidos feitos pela clientela e entrega-los ao cozinheiro para
efetivar o preparo; e o cozinheiro, que é responsável por efetivamente cozinhar os pedidos recebidos e disponibiza-los para
o garçom.

O domínio é descrito como simplificado porque, pelo mais que ele descreva os processos acima de forma bem detalhada, ele
excluí outras situações que normalmente ocorreriam, tais como o cliente ter que pagar pelo pedido ou realizar múltiplos
pedidos diferentes.

A ideia do domínio surgiu quando nós estavamos em uma franquia de restaurantes do Gama, DF, e, ao reclamar do péssimo
atendimento do local, começamos a estipular como que o processo de atendimento dos clientes poderia ser descrito de forma
programática. Brincando, foi sugerido que, caso o estabelecimento utilizasse um planner de PDDL para o seu funcionamento,
talvez a qualidade do restaurante melhorasse. E assim, nasceu o Quick Bite.

## Funcionamento
O domínio funciona com três diferentes atores:

- O garçom
- O cozinheiro
- O cliente

E outros objetos utilitários.

A ideia básica é que o garçom deve disponibilizar o pedido para que o cozinheiro obtenha o conhecimento do que ele deve
preparar, portanto, o adicional desse domínio em relação aos demais é o fato da transmissão do conhecimento percorrer
cliente-garçom-cozinheiro para que ele possa gerar o pedido e servir o cliente.

### Cliente
O cliente serve com base e solução para todo problema, ou seja, são os pedidos realizados pelos clientes que servem como
as condições iniciais do problema e o objetivo é atingido quando todos os pedidos foram entregues. No início de cada problema,
cada cliente terá um pedido diferente. Assim que um cliente é atendido pelo garçom, o cliente entrará em um estado de espera,
onde não poderá ser mais atendido. Finalmente, quando o cliente recebe seu pedido, o cliente estará satisfeito e fora do
problema.

### Garçom
O garçom é responsável por pegar os pedidos, cujo serão encaminhados ao cozinheiro, e depois entrega-los aos clientes. Primeiramente,
o garçom se movimentará para um dos clientes para atende-lo. Após atender um cliente, ele obrigatóriamente encaminhará o pedido ao
cozinheiro, deixando ele no que chamamos de bancada, local onde o garçom e cozinheiro se comunicam. Assim que um pedido é preparado
e está pronto para ser entregue, o garçom retornará a bancada para pegar o pedido e o levará para o cliente. O garçom só pode
carregar uma coisa - isto é, o pedido realizado ou a comida pronta - por vez.

### Cozinheiro
O cozinheiro é responsável por receber os pedidos encaminhados pelo garçom e prepara-los. Primeiramente, o cozinheiro terá que
esperar o garçom deixar um pedido na bancada. Assim que um pedido for recebido, o cozinheiro moverá para o fogão, onde o pedido
será preparado. Assim que o pedido for preparado, o cozinheiro irá para a bancada para deixar a comida, onde o garçom poderá pegar
o pedido e entrega-lo. O cozinheiro, similarmente ao garçom, só pode cozinhar um pedido por vez, ou seja, enquanto ele cozinha, novos
pedidos não serão realizados. 

### Order (pedido)
Uma order, isto é, um pedido, é o objeto responsável pela comunicação entre os três atores. Pode-se imaginar que uma order é um pequeno
papel no qual o pedido do cliente foi escrito. Uma order pode-se referir apenas a uma comida, contudo, uma comida pode ser referida por
diferentes orders. Ela é primeiramente emitida pelo cliente e depois encaminhada ao cozinheiro.

### Comida
Uma comida é o objeto que descreve o estado final do pedido, ou seja, quando ele já foi cozinhado. Ela é responsável por marcar um cliente
como satisfeito, assim cumprindo os objetivos de cada problema. Ela é produzida pelo cozinheiro que, então, a entregará para o garçom que,
finalmente, a entregará ao cliente.

### Outros
Os demais objetos do domínio são utilizados para representar os locais em que os atores podem traversar: o fogão, a bancada.
O fogão é utilizado pelo cozinheiro para o preparo de pedidos; a bancada é utilizado pelo cozinheiro e pelo garçom para a interação.
Antes do finalizamento do domínio, havia, também, uma lixeira que seria utilizada pelo cozinheiro em certos casos, contudo, ela foi
retirada do domínio por falta de uso.

## Geração de problemas
Os problemas de HDDL podem ser gerados a partir do programa em C++ disponibilizado com o repositório do projeto. Os binários serão
disponibilizados, contudo, é recomendado que a compilação seja feita pelo usuário final. Mais instruções sobre
o processo de compilação estão disponibilizadas no README. 

O gerador de problemas, ao ser executado, dará ao usuário diferentes opções de customização do problema, possibilitando gerar um
arquivo HDDL com a complexidade desejada. 

## Comentários e observações
> **Atenção** Área de opiniões pessoais e comentários sentimentais.

O projeto, pelo mais que tenha sido difícil de se desenvolver devido a nossa grande ignorância quanto ao funcionamento do HDDL cujo
culpa nós falsamente atribuíremos à falta de documentação da linguagem, foi divertido de se fazer. O reprovamento da matéria é quase
inevitável, mas isso não significa que eu vou desistir da matéria permanentemente, pois eu amei o método de ensino aplicado, onde a 
prática prevalece sobre a teoria - algo que eu sinto que faz falta na nossa faculdade de engenharia, assim como um CA para os alunos e WI-FI
semi-funcional. O único arrependimento que eu tive ao longo do semestre foi não ter tido o tempo e organização necessária para me 
dedicar mais aos projetos realizados - Caio Urnau.

Violência :>. - Ryan Salles



